Name:           cadical
Version:        06w
Release:        2%{?dist}
Summary:        Simplified SAT solver

License:        MIT
URL:            http://fmv.jku.at/cadical/
Source0:        https://github.com/arminbiere/%{name}/archive/rel-%{version}.tar.gz
# Fedora-only patch: build a shared library instead of a static library
Patch0:         %{name}-shared.patch
# Patch to be sent upstream: fix out-of-bounds vector accesses
Patch1:         %{name}-vector.patch

BuildRequires:  drabt
BuildRequires:  gcc-c++
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description
CaDiCaL is a simplified Satisfiability solver.  The goal of the
development of CaDiCaL is to obtain a CDCL solver, which is easy to
understand and change, while at the same time not being much slower
than other state-of-the-art CDCL solvers.

%package libs
Summary:        Simplified SAT solver library

%description libs
This package contains the CaDiCaL simplified Satisfiability solver as a
library, for use in applications that need a SAT solver.

%package devel
Summary:        Development files for %{name}
Requires:       %{name}-libs%{?_isa} = %{version}-%{release}

%description devel
Library links and header files for developing applications that use
%{name}.

%prep
%autosetup -p0 -n %{name}-rel-%{version}

# We have commas in optflags, so commas can't be used as sed delimiters in
# the configure script.
sed -i '/^-e/s/,/|/g' configure

# Fix build flags in the tests
sed -i 's|-g|%{optflags}|' test/run-api-tests.sh

%build
# The configure script is NOT generated by autoconf.  Do NOT use the
# %%configure macro here.
CXXFLAGS="%{optflags} -fPIC" ./configure --no-realloc
%make_build

%install
# The makefile has no install target.  Install by hand.
# Install the binary
mkdir -p %{buildroot}%{_bindir}
cp -p build/cadical %{buildroot}%{_bindir}

# Install the library
mkdir -p %{buildroot}%{_libdir}
cp -p build/libcadical.so.0.0.0 %{buildroot}%{_libdir}
ln -s libcadical.so.0.0.0 %{buildroot}%{_libdir}/libcadical.so.0
ln -s libcadical.so.0 %{buildroot}%{_libdir}/libcadical.so

# Install the header files
mkdir -p %{buildroot}%{_includedir}
cp -p src/cadical.hpp %{buildroot}%{_includedir}

%check
export LD_LIBRARY_PATH=$PWD/build
make test

%files
%{_bindir}/%{name}

%files libs
%license LICENSE
%doc CONTRIBUTING README.md
%{_libdir}/lib%{name}.so.*

%files devel
%{_includedir}/%{name}.hpp
%{_libdir}/lib%{name}.so

%changelog
* Thu Jul 12 2018 Fedora Release Engineering <releng@fedoraproject.org> - 06w-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Jul  6 2018 Jerry James <loganjerry@gmail.com> - 06w-1
- Initial RPM
